/*
 *  TOPPERS ATK2
 *      Toyohashi Open Platform for Embedded Real-Time Systems
 *      Automotive Kernel Version 2
 *
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2004-2015 by Center for Embedded Computing Systems
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *  Copyright (C) 2011-2015 by FUJI SOFT INCORPORATED, JAPAN
 *  Copyright (C) 2011-2013 by Spansion LLC, USA
 *  Copyright (C) 2011-2015 by NEC Communication Systems, Ltd., JAPAN
 *  Copyright (C) 2011-2015 by Panasonic Advanced Technology Development Co., Ltd., JAPAN
 *  Copyright (C) 2011-2014 by Renesas Electronics Corporation, JAPAN
 *  Copyright (C) 2011-2015 by Sunny Giken Inc., JAPAN
 *  Copyright (C) 2011-2015 by TOSHIBA CORPORATION, JAPAN
 *  Copyright (C) 2004-2015 by Witz Corporation
 *  Copyright (C) 2014-2015 by AISIN COMCRUISE Co., Ltd., JAPAN
 *  Copyright (C) 2014-2015 by eSOL Co.,Ltd., JAPAN
 *  Copyright (C) 2014-2015 by SCSK Corporation, JAPAN
 *
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 *
 *  ܥեȥϡAUTOSARAUTomotive Open System ARchitecture˻
 *  ͤ˴ŤƤ롥嵭εϡAUTOSARŪ⻺Τ
 *  ϤʤAUTOSARϡAUTOSARͤ˴ŤեȥŪ
 *  ѤԤФơAUTOSARѡȥʡˤʤ뤳ȤƤ롥
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 *
 *  $Id: alarm.h 677 2015-03-24 02:52:27Z t_ishikawa $
 */

/*
 *		顼ൡǽ
 */

#ifndef TOPPERS_ALARM_H
#define TOPPERS_ALARM_H

#include "counter.h"

/*
 *  顼ID饢顼֥åФΥޥ
 */
#define get_almcb(almid)	(&(almcb_table[(almid)]))

/*
 *  顼֥å
 */
typedef struct alarm_initialization_block {
	CNTCB			*p_cntcb;       /* ư󥿴֥åΥݥ */
	FunctionRefType	action;         /* 顼λ */
	AppModeType		autosta;        /* ư⡼ */
	TickType		almval;         /* expire ƥå */
	TickType		cycle;          /* 顼μ */
	AttributeType	actatr;         /* λ󡦼ưư° */
} ALMINIB;

/*
 *  顼֥å
 */
typedef struct alarm_control_block {
	CNTEXPINFO		cntexpinfo;     /* λ(¤ΤƬɬ) */
	const ALMINIB	*p_alminib;     /* 顼֥åݥ */
	TickType		cycle;          /* 顼μ */
} ALMCB;

/*
 *  顼ݻѿOs_Lcfg.c
 */
extern const AlarmType	tnum_alarm;    /* 顼ο */

/*
 *  顼֥åΥꥢOs_Lcfg.c
 */
extern const ALMINIB	alminib_table[];

/*
 *  顼֥åΥꥢOs_Lcfg.c
 */
extern ALMCB			almcb_table[];

/*
 *  顼ൡǽν
 */
extern void alarm_initialize(void);

/*
 *  顼λѴؿ
 */
extern void alarm_expire(CNTEXPINFO *p_cntexpinfo, const CNTCB *p_cntcb);

#endif /* TOPPERS_ALARM_H */
