/*
 *  TOPPERS ATK2
 *      Toyohashi Open Platform for Embedded Real-Time Systems
 *      Automotive Kernel Version 2
 *
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2004-2015 by Center for Embedded Computing Systems
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *  Copyright (C) 2011-2015 by FUJI SOFT INCORPORATED, JAPAN
 *  Copyright (C) 2011-2013 by Spansion LLC, USA
 *  Copyright (C) 2011-2015 by NEC Communication Systems, Ltd., JAPAN
 *  Copyright (C) 2011-2015 by Panasonic Advanced Technology Development Co., Ltd., JAPAN
 *  Copyright (C) 2011-2014 by Renesas Electronics Corporation, JAPAN
 *  Copyright (C) 2011-2015 by Sunny Giken Inc., JAPAN
 *  Copyright (C) 2011-2015 by TOSHIBA CORPORATION, JAPAN
 *  Copyright (C) 2004-2015 by Witz Corporation
 *  Copyright (C) 2014-2015 by AISIN COMCRUISE Co., Ltd., JAPAN
 *  Copyright (C) 2014-2015 by eSOL Co.,Ltd., JAPAN
 *  Copyright (C) 2014-2015 by SCSK Corporation, JAPAN
 *
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 *
 *  ܥեȥϡAUTOSARAUTomotive Open System ARchitecture˻
 *  ͤ˴ŤƤ롥嵭εϡAUTOSARŪ⻺Τ
 *  ϤʤAUTOSARϡAUTOSARͤ˴ŤեȥŪ
 *  ѤԤФơAUTOSARѡȥʡˤʤ뤳ȤƤ롥
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 *
 *  $Id: osctl.c 695 2015-03-24 07:25:34Z esol-senzaki $
 */

/*
 *		OS⥸塼
 */

#include "kernel_impl.h"
#include "interrupt.h"
#include "task.h"

/*
 *  ȥ졼ޥΥǥե
 */

#ifndef LOG_ERRHOOK_ENTER
#define LOG_ERRHOOK_ENTER(ercd)
#endif /* LOG_ERRHOOK_ENTER */

#ifndef LOG_ERRHOOK_LEAVE
#define LOG_ERRHOOK_LEAVE()
#endif /* LOG_ERRHOOK_LEAVE */

#ifndef LOG_PROHOOK_ENTER
#define LOG_PROHOOK_ENTER(ercd)
#endif /* LOG_PROHOOK_ENTER */

#ifndef LOG_PROHOOK_LEAVE
#define LOG_PROHOOK_LEAVE(pret)
#endif /* LOG_PROHOOK_LEAVE */

#ifndef LOG_SHUTHOOK_ENTER
#define LOG_SHUTHOOK_ENTER(ercd)
#endif /* LOG_SHUTHOOK_ENTER */

#ifndef LOG_SHUTHOOK_LEAVE
#define LOG_SHUTHOOK_LEAVE()
#endif /* LOG_SHUTHOOK_LEAVE */

#ifndef LOG_STUTOS_ENTER
#define LOG_STUTOS_ENTER(ercd)
#endif /* LOG_STUTOS_ENTER */

#ifndef LOG_STUTOS_LEAVE
#define LOG_STUTOS_LEAVE()
#endif /* LOG_STUTOS_LEAVE */

#ifdef CFG_USE_ERRORHOOK
/*
 *  顼եåϤǼѿ
 */
#ifdef TOPPERS_internal_call_errorhook

#ifdef CFG_USE_GETSERVICEID
OSServiceIdType	_errorhook_svcid;
#endif /* CFG_USE_GETSERVICEID */

#ifdef CFG_USE_PARAMETERACCESS
_ErrorHook_Par	_errorhook_par1;
_ErrorHook_Par	_errorhook_par2;
_ErrorHook_Par	_errorhook_par3;
_ErrorHook_Par	errorhook_par1;
_ErrorHook_Par	errorhook_par2;
_ErrorHook_Par	errorhook_par3;
#endif /* CFG_USE_PARAMETERACCESS */

/*
 *  顼եåθƤӽФ
 */
void
internal_call_errorhook(StatusType ercd, OSServiceIdType svcid)
{
	void (*volatile errorhook_adr) (StatusType Error);
	uint8	saved_sus_all_cnt_ctx;
	uint8	saved_sus_os_cnt_ctx;

	/*
	 *  CεʤǤϴؿΥɥ쥹0ˤʤʤȤ󤫤,
	 *  ѥκŬˤErrorHookΥɥ쥹Ƚʬ
	 *  Ƥޤ礬뤿, volatileꤷѿ
	 *  ɥ쥹ƤȽꤷƤ
	 */
	errorhook_adr = &ErrorHook;

	if (errorhook_adr != NULL) {
		if ((callevel_stat & (TCL_ERROR | TSYS_ISR1)) == TCL_NULL) {

#ifdef CFG_USE_GETSERVICEID
			_errorhook_svcid = svcid;
#endif /* CFG_USE_GETSERVICEID */

#ifdef CFG_USE_PARAMETERACCESS
			errorhook_par1 = _errorhook_par1;
			errorhook_par2 = _errorhook_par2;
			errorhook_par3 = _errorhook_par3;
#endif /* CFG_USE_PARAMETERACCESS */

			saved_sus_all_cnt_ctx = sus_all_cnt_ctx;
			saved_sus_os_cnt_ctx = sus_os_cnt_ctx;

			sus_all_cnt_ctx = 0U;
			sus_os_cnt_ctx = 0U;

			ENTER_CALLEVEL(TCL_ERROR);
			LOG_ERRHOOK_ENTER(ercd);
			ErrorHook(ercd);
			LOG_ERRHOOK_LEAVE();
			LEAVE_CALLEVEL(TCL_ERROR);

			release_interrupts(OSServiceId_HookMissingEnd);

			sus_all_cnt_ctx = saved_sus_all_cnt_ctx;
			sus_os_cnt_ctx = saved_sus_os_cnt_ctx;
		}
	}
}

#endif /* TOPPERS_internal_call_errorhook */

#endif /* CFG_USE_ERRORHOOK */

#ifdef CFG_USE_POSTTASKHOOK
/*
 *  ݥȥեåθƤӽФ
 */
#ifdef TOPPERS_call_posttaskhook

void
call_posttaskhook(void)
{
	ENTER_CALLEVEL(TCL_PREPOST);
	PostTaskHook();
	LEAVE_CALLEVEL(TCL_PREPOST);

	release_interrupts(OSServiceId_HookMissingEnd);
}

#endif /* TOPPERS_call_posttaskhook */

#endif /* CFG_USE_POSTTASKHOOK */

#ifdef CFG_USE_PRETASKHOOK
/*
 *  ץ쥿եåθƤӽФ
 */
#ifdef TOPPERS_call_pretaskhook

void
call_pretaskhook(void)
{
	ENTER_CALLEVEL(TCL_PREPOST);
	PreTaskHook();
	LEAVE_CALLEVEL(TCL_PREPOST);

	release_interrupts(OSServiceId_HookMissingEnd);
}

#endif /* TOPPERS_call_pretaskhook */

#endif /* CFG_USE_PRETASKHOOK */

#ifdef CFG_USE_STACKMONITORING

#ifdef TOPPERS_init_stack_magic_region

/*
 *  å˥󥰵ǽν
 *  å˥󥰵ǽΤΥޥåʥСΰν
 */
void
init_stack_magic_region(void)
{
	TaskType	i;
	StackType	*p_stack_magic_region;

	/*
	 *  å˥󥰵ǽΤᡤåĹθ
	 *  󥿥åΥޥåʥСΰν
	 */
	p_stack_magic_region = TOPPERS_ISTK_MAGIC_REGION(_ostk, _ostksz);
	*p_stack_magic_region = STACK_MAGIC_NUMBER;

	/*
	 *  å˥󥰵ǽΤᡤåĹθ
	 *  ƥåΥޥåʥСΰν
	 *  åͭΥޥåʥСΰ褬碌äƤ
	 */
	for (i = 0U; i < tnum_task; i++) {
		p_stack_magic_region =
			TOPPERS_TSTK_MAGIC_REGION(&tinib_table[i]);
		*p_stack_magic_region = STACK_MAGIC_NUMBER;
	}
}

#endif /* TOPPERS_init_stack_magic_region */

#endif /* CFG_USE_STACKMONITORING */

/*
 *  ץƥեåθƤӽФ
 */
#ifdef TOPPERS_call_protectionhk_main

void
call_protectionhk_main(StatusType ercd)
{

#ifdef CFG_USE_PROTECTIONHOOK

	ProtectionReturnType	pret;
	ProtectionReturnType	(*volatile protectionhook_adr) (StatusType FatalError);
	uint8					saved_sus_all_cnt_ctx;
	uint8					saved_sus_os_cnt_ctx;

	/* ץƥեå¹ݸȿȯ */
	if ((callevel_stat & TCL_PROTECT) == TCL_PROTECT) {
		internal_shutdownos(E_OS_PROTECTION_FATAL);
	}

	/*
	 *  CεʤǤϴؿΥɥ쥹0ˤʤʤȤ󤫤,
	 *  ѥκŬˤProtectionHookΥɥ쥹Ƚʬ
	 *  Ƥޤ礬뤿, volatileꤷѿ
	 *  ɥ쥹ƤȽꤷƤ
	 */
	protectionhook_adr = &ProtectionHook;

	/* ʲ ƥΥץƥեåƽФ */
	if (protectionhook_adr != NULL) {

		saved_sus_all_cnt_ctx = sus_all_cnt_ctx;
		saved_sus_os_cnt_ctx = sus_os_cnt_ctx;

		sus_all_cnt_ctx = 0U;
		sus_os_cnt_ctx = 0U;

		ENTER_CALLEVEL(TCL_PROTECT);
		LOG_PROHOOK_ENTER(ercd);
		pret = protectionhook_adr(ercd);
		LOG_PROHOOK_LEAVE(pret);

		LEAVE_CALLEVEL(TCL_PROTECT);

		release_interrupts(OSServiceId_HookMissingEnd);

		sus_all_cnt_ctx = saved_sus_all_cnt_ctx;
		sus_os_cnt_ctx = saved_sus_os_cnt_ctx;

		/* ʲ ProtectionHook ¹Ըν */
		switch (pret) {
		case PRO_SHUTDOWN:
			internal_shutdownos(ercd);
			break;
		case PRO_TERMINATETASKISR:
			if ((ercd == E_OS_PROTECTION_TIME_TASK) || (ercd == E_OS_PROTECTION_LOCKED_RESOURCE) || (ercd == E_OS_PROTECTION_LOCKED_OSINT)) {
				/* ߥݸȿξ */
				if ((p_runisr == NULL) && (p_runtsk != NULL)) {
					/* ξ */
					force_terminate_task(p_runtsk, ercd);
					/*
					 * ʤ
					 */
				}
			}
			internal_shutdownos(E_OS_PROTECTION_FATAL);
			break;
		case PRO_IGNORE:
			if ((ercd != E_OS_PROTECTION_EXCEPTION) && (ercd != E_OS_PROTECTION_ARRIVAL_ISR)) {
				internal_shutdownos(E_OS_PROTECTION_FATAL);
			}
			break;
		default:
			/* ProtectionHook֤ͤä */
			internal_shutdownos(E_OS_PROTECTION_FATAL);
			break;
		}
	}
	else {
		internal_shutdownos(ercd);
	}

#else /* CFG_USE_PROTECTIONHOOK */

	/*
	 *  ץƥեåե졼̵
	 *  Ƥ硤OSݸȿȤOSåȥ
	 *  Ԥ
	 *  ΤȤOSåȥΥѥ᡼Ȥơ
	 *  ȿζ̤򼨤顼ɤꤹ
	 */
	internal_shutdownos(ercd);
#endif /* CFG_USE_PROTECTIONHOOK */

}

#endif /* TOPPERS_call_protectionhk_main */

/*
 *  OSShutdownOSθƤӽФ
 */
#ifdef TOPPERS_internal_shutdownos

void
internal_shutdownos(StatusType ercd)
{
	LOG_STUTOS_ENTER(ercd);

	x_nested_lock_os_int();

#ifdef CFG_USE_SHUTDOWNHOOK
	call_shutdownhook(ercd);
#endif /* CFG_USE_SHUTDOWNHOOK */

	/* ƥ⥸塼νλ */
	object_terminate();

	/* ߶ػ߾֤˰ܹ */
	x_lock_all_int();

	LOG_STUTOS_LEAVE();

	/* åȰ¸νλ */
	target_exit();

	/*
	 * åȰ¸֤äƤ硤
	 * ̵¥롼פԤ
	 */
	while (1) {
	}

}

#endif /* TOPPERS_internal_shutdownos */

#ifdef TOPPERS_internal_call_shtdwnhk

#ifdef CFG_USE_SHUTDOWNHOOK

void
internal_call_shtdwnhk(StatusType ercd)
{

	void (*volatile shutdownhook_adr) (StatusType Error);

	/*
	 *  åȥեåΥåȥǤϥåȥեå
	 *  ϸƤӽФʤ
	 */
	if ((callevel_stat & TCL_SHUTDOWN) == TCL_NULL) {
		/*
		 *  ShutdownHook θƤӽФ
		 *
		 *  CεʤǤϴؿΥɥ쥹0ˤʤʤȤ󤫤,
		 *  ѥκŬˤShutdownHookΥɥ쥹Ƚʬ
		 *  Ƥޤ礬뤿, volatileꤷѿ
		 *  ɥ쥹ƤȽꤷƤ
		 */
		shutdownhook_adr = &ShutdownHook;

		if (shutdownhook_adr != NULL) {
			sus_all_cnt_ctx = 0U;
			sus_os_cnt_ctx = 0U;

			ENTER_CALLEVEL(TCL_SHUTDOWN);
			LOG_SHUTHOOK_ENTER(ercd);
			ShutdownHook(ercd);
			LOG_SHUTHOOK_LEAVE();
			LEAVE_CALLEVEL(TCL_SHUTDOWN);

			release_interrupts(OSServiceId_HookMissingEnd);
		}
	}
}
#endif /* CFG_USE_SHUTDOWNHOOK */

#endif /* TOPPERS_internal_call_shtdwnhk */
