/*
 *  TOPPERS ATK2
 *      Toyohashi Open Platform for Embedded Real-Time Systems
 *      Automotive Kernel Version 2
 *
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2004-2015 by Center for Embedded Computing Systems
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *  Copyright (C) 2011-2015 by FUJI SOFT INCORPORATED, JAPAN
 *  Copyright (C) 2011-2013 by Spansion LLC, USA
 *  Copyright (C) 2011-2015 by NEC Communication Systems, Ltd., JAPAN
 *  Copyright (C) 2011-2015 by Panasonic Advanced Technology Development Co., Ltd., JAPAN
 *  Copyright (C) 2011-2014 by Renesas Electronics Corporation, JAPAN
 *  Copyright (C) 2011-2015 by Sunny Giken Inc., JAPAN
 *  Copyright (C) 2011-2015 by TOSHIBA CORPORATION, JAPAN
 *  Copyright (C) 2004-2015 by Witz Corporation
 *  Copyright (C) 2014-2015 by AISIN COMCRUISE Co., Ltd., JAPAN
 *  Copyright (C) 2014-2015 by eSOL Co.,Ltd., JAPAN
 *  Copyright (C) 2014-2015 by SCSK Corporation, JAPAN
 *
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 *
 *  ܥեȥϡAUTOSARAUTomotive Open System ARchitecture˻
 *  ͤ˴ŤƤ롥嵭εϡAUTOSARŪ⻺Τ
 *  ϤʤAUTOSARϡAUTOSARͤ˴ŤեȥŪ
 *  ѤԤФơAUTOSARѡȥʡˤʤ뤳ȤƤ롥
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 *
 *  $Id: task.c 739 2015-03-30 07:09:39Z hibino.yuu $
 */

/*
 *		⥸塼
 */

#include "kernel_impl.h"
#include "check.h"
#include "task.h"
#include "interrupt.h"

/*
 *  ȥ졼ޥΥǥե
 */
#ifndef LOG_TSKSTAT
#define LOG_TSKSTAT(p_tcb)
#endif /* LOG_TSKSTAT */

/* ؿΥץȥ */
LOCAL_INLINE uint16 bitmap_search(uint16 bitmap);
LOCAL_INLINE boolean primap_empty(void);
LOCAL_INLINE PriorityType primap_search(void);
LOCAL_INLINE void primap_set(PriorityType pri);
LOCAL_INLINE void primap_clear(PriorityType pri);

#ifdef TOPPERS_task_initialize

/*
 *  ¹Ծ֤Υ
 */
TCB				*p_runtsk;

/*
 *  ǹ̥ͥ
 */
TCB				*p_schedtsk;

/*
 *  ǥ塼κǹͥ
 */
PriorityType	nextpri;

/*
 *  ǥ塼
 */
QUEUE			ready_queue[TNUM_TPRI];

/*
 *  ǥ塼ΤΥӥåȥޥå
 */
uint16			ready_primap;

/*
 *  ⥸塼ν
 */
void
task_initialize(void)
{
	TaskType	i;
	TCB			*p_tcb;

	p_runtsk = NULL;
	p_schedtsk = NULL;

	for (i = 0U; i < TNUM_TPRI; i++) {
		queue_initialize(&(ready_queue[i]));
	}
	nextpri = TPRI_MINTASK;
	ready_primap = 0U;

	for (i = 0U; i < tnum_task; i++) {
		p_tcb = &(tcb_table[i]);
		p_tcb->p_tinib = &(tinib_table[i]);
		p_tcb->actcnt = 0U;
		p_tcb->curevt = 0U;
		p_tcb->tstat = SUSPENDED;
		p_tcb->tpcb.lastarrival.count = 0U;
		p_tcb->tpcb.lastarrival.tick = 0U;
		p_tcb->tpcb.is_not_first = FALSE;
		p_tcb->tpcb.remaining_execution = 0U;
		p_tcb->tpcb.watchtype = NON_MONITORING;
		if ((p_tcb->p_tinib->autoact & ((AppModeType) 1 << appmodeid)) != APPMODE_NONE) {
			p_tcb->tpcb.is_not_first = TRUE;
			(void) make_active(p_tcb);
		}
	}
}

#endif /* TOPPERS_task_initialize */

/*
 *  ӥåȥޥåץؿ
 *
 *  bitmap1ΥӥåȤ⡤ǤⲼ̡ʱˤΤΤ򥵡Υӥ
 *  ֹ֤
 *  ӥåֹϡǲ̥ӥåȤ0Ȥ롥bitmap0
 *  ƤϤʤʤδؿǤϡbitmap16ӥåȤǤ뤳Ȥꤷ
 *  uint16ȤƤ
 *
 *  ӥåȥ̿ĥץåǤϡӥåȥ̿Ȥ褦
 *  ľΨɤ礬
 *  Τ褦ʾˤϡåȰ¸ǥӥåȥ̿Ȥä
 *  bitmap_searchOMIT_BITMAP_SEARCHޥФ褤
 *  ޤӥåȥ̿Υդʤɤͳͥ٤ȥӥå
 *  ȤбѹˤϡPRIMAP_BITޥФ褤
 *
 *  ޤɸ饤֥ffsʤ顤Τ褦ɸ饤
 *  ȤäΨɤǽ⤢
 *		#define	bitmap_search(bitmap) (ffs(bitmap) - 1)
 */
#ifndef PRIMAP_BIT
#define PRIMAP_BIT(pri)		((uint16) ((uint16) 1U << (pri)))
#endif /* PRIMAP_BIT */

#ifndef OMIT_BITMAP_SEARCH

LOCAL_INLINE uint16
bitmap_search(uint16 bitmap)
{
	/*
	 *  ӥåȥޥåץؿѥơ֥
	 */
	const uint8	bitmap_search_table[BITMAP_NUM] = {
		0U, 1U, 0U, 2U, 0U, 1U, 0U,
		3U, 0U, 1U, 0U, 2U, 0U, 1U, 0U
	};

	uint16		n = 0U;

	ASSERT(bitmap != 0U);
	if ((bitmap & 0x00ffU) == 0U) {
		bitmap >>= 8U;
		n += 8U;
	}
	if ((bitmap & 0x0fU) == 0U) {
		bitmap >>= 4U;
		n += 4U;
	}
	return(n + bitmap_search_table[(bitmap & 0x000fU) - 1U]);
}

#endif /* OMIT_BITMAP_SEARCH */

/*
 *  ͥ٥ӥåȥޥåפΥå
 */
LOCAL_INLINE boolean
primap_empty(void)
{
	return(ready_primap == 0U);
}

/*
 *  ͥ٥ӥåȥޥåפΥ
 */
LOCAL_INLINE PriorityType
primap_search(void)
{
	return((PriorityType) bitmap_search(ready_primap));
}

/*
 *  ͥ٥ӥåȥޥåפΥå
 */
LOCAL_INLINE void
primap_set(PriorityType pri)
{
	ready_primap |= PRIMAP_BIT(pri);
}

/*
 *  ͥ٥ӥåȥޥåפΥꥢ
 */
LOCAL_INLINE void
primap_clear(PriorityType pri)
{
	ready_primap &= (uint16) ~PRIMAP_BIT(pri);
}

/*
 *  ǹ̥ͥΥ
 */
#ifdef TOPPERS_search_schedtsk

void
search_schedtsk(void)
{
	if (primap_empty() != FALSE) {
		p_schedtsk = NULL;
	}
	else {
		p_schedtsk = (TCB *) (queue_delete_next(&(ready_queue[nextpri])));
		if (queue_empty(&(ready_queue[nextpri])) != FALSE) {
			primap_clear(nextpri);
			nextpri = (primap_empty() != FALSE) ?
					  TPRI_MINTASK : primap_search();
		}
	}
}

#endif /* TOPPERS_search_schedtsk */

/*
 *  ¹ԤǤ֤ؤΰܹ
 */
#ifdef TOPPERS_make_runnable

boolean
make_runnable(TCB *p_tcb)
{
	PriorityType	pri, schedpri;
	boolean			is_next_schedtsk = TRUE;

	if (p_tcb->p_tinib->tpinib.execution_budget != 0U) {
		p_tcb->tpcb.watchtype = TASK_MONITORING;
	}
	else {
		p_tcb->tpcb.watchtype = NON_MONITORING;
	}
	p_tcb->tpcb.remaining_execution = p_tcb->p_tinib->tpinib.execution_budget;

	p_tcb->tstat = READY;
	LOG_TSKSTAT(p_tcb);
	if (p_schedtsk != NULL) {
		pri = p_tcb->curpri;
		schedpri = p_schedtsk->curpri;
		if (pri >= schedpri) {
			/*
			 *  schedtsk ͥ٤⤤硤p_tcb 
			 *  ǥ塼κǸ
			 */
			queue_insert_prev(&(ready_queue[pri]), &(p_tcb->task_queue));
			primap_set(pri);
			if (pri < nextpri) {
				nextpri = pri;
			}
			is_next_schedtsk = FALSE;
		}
		else {
			/*
			 *  p_tcb ͥ٤⤤硤schedtsk ǥ塼
			 *  Ƭ졤p_tcb 򿷤 schedtsk Ȥ
			 */
			queue_insert_next(&(ready_queue[schedpri]), &(p_schedtsk->task_queue));
			primap_set(schedpri);
			nextpri = schedpri;
		}
	}

	if (is_next_schedtsk != FALSE) {
		p_schedtsk = p_tcb;
	}
	return(is_next_schedtsk);
}

#endif /* TOPPERS_make_runnable */

/*
 *  ¹ԤǤ֤¾ξ֤ؤ
 *
 *  SC1-MCmake_non_runnable뤿
 *  SC1ˤmake_non_runableSC1SC1-MCδؿ˹礻
 *  SC1-MCǤϡp_runtskp_schedtskפƤ뤳Ȥǧɬפ뤬
 *  SC1Ǥϡsearch_schedtskΤ߸ƤӽФȤ
 */
#ifdef TOPPERS_make_non_runnable

void
make_non_runnable(void)
{
	search_schedtsk();
}

#endif /* TOPPERS_make_non_runnable */

/*
 *  εư
 *
 *  TerminateTask  ChainTask ǡФ make_active 
 *  Ƥ־礬Τդ
 */
#ifdef TOPPERS_make_active

boolean
make_active(TCB *p_tcb)
{
	p_tcb->curpri = p_tcb->p_tinib->inipri;
	if (TSKID(p_tcb) < tnum_exttask) {
		p_tcb->curevt = EVTMASK_NONE;
		p_tcb->waievt = EVTMASK_NONE;
	}
	p_tcb->p_lastrescb = NULL;
	activate_context(p_tcb);
	return(make_runnable(p_tcb) != FALSE);
}

#endif /* TOPPERS_make_active */

/*
 *  Υץꥨץ
 */
#ifdef TOPPERS_preempt

void
preempt(void)
{
	PriorityType pri;

	ASSERT(p_runtsk == p_schedtsk);
	pri = p_runtsk->curpri;
	queue_insert_next(&(ready_queue[pri]), &(p_runtsk->task_queue));
	primap_set(pri);
	search_schedtsk();
}

#endif /* TOPPERS_preempt */

/*
 *  ¹ΥSUSPENDED֤ˤ
 */
#ifdef TOPPERS_suspend

void
suspend(void)
{
	p_runtsk->tstat = SUSPENDED;
	LOG_TSKSTAT(p_runtsk);
	make_non_runnable();
	if (p_runtsk->actcnt > 0U) {
		p_runtsk->actcnt -= 1U;
		(void) make_active(p_runtsk);
	}
}

#endif /* TOPPERS_suspend */

/*
 *  ꥽ֵ
 */
#ifdef TOPPERS_release_taskresources

void
release_taskresources(TCB *p_tcb)
{
	if (p_tcb->p_lastrescb != NULL) {
		if (p_tcb->curpri <= TPRI_MINISR) {
			/* ꥽гߵĤˤʤ */
			x_set_ipm((PriorityType) TIPM_ENAALL);
		}
		/* ꥽м¹ͥ٤ */
		p_tcb->curpri = p_tcb->p_tinib->exepri;

		/* OS߶ػ߾ְʾ */
		do {
			p_tcb->p_lastrescb->lockflg = FALSE;
			p_tcb->p_lastrescb->res_saved_watchtype = NON_MONITORING;
			p_tcb->p_lastrescb->res_difftime = 0U;
			p_tcb->p_lastrescb = p_tcb->p_lastrescb->p_prevrescb;
		} while (p_tcb->p_lastrescb != NULL);
	}
}

#endif /* TOPPERS_release_taskresources */

/*
 *  Υ󥿤ξ֤򤹤٤CS_NULL᤹
 */
#ifdef TOPPERS_cancel_taskcounters

void
cancel_taskcounters(TCB *p_tcb)
{
	if (p_tcb->p_lastcntcb != NULL) {

		/* OS߶ػ߾ְʾ */
		do {
			p_tcb->p_lastcntcb->cstat = CS_NULL;
			p_tcb->p_lastcntcb = p_tcb->p_lastcntcb->p_prevcntcb;
		} while (p_tcb->p_lastcntcb != NULL);
	}
}
#endif /* TOPPERS_cancel_taskcounters */

/*
 *  λݸ
 *  TerminateTask()ChainTask()ʤǤμνλ
 * ʥδؿ꥿ˤν
 */
#ifdef TOPPERS_exit_task

void
exit_task(void)
{
	x_nested_lock_os_int();

	/* ߶ػ߾֤ξϳ߶ػߤ */
	release_interrupts(OSServiceId_Invalid);

	/* ꥽ݤޤޤξϥ꥽ */
	release_taskresources(p_runtsk);

#ifdef CFG_USE_ERRORHOOK
	/* 顼եåƤ */
	call_errorhook(E_OS_MISSINGEND, OSServiceId_TaskMissingEnd);
#endif /* CFG_USE_ERRORHOOK */

	suspend();

	/* ݥȥեåͭʾϥݥȥեåƤФ */
	exit_and_dispatch();
}

#endif /* TOPPERS_exit_task */

#ifdef TOPPERS_remove_task_from_queue

/*
 *  ǥ塼饿
 */
void
remove_task_from_queue(TCB *p_tcb, PriorityType remove_task_pri)
{
	/*
	 *  TerminateTaskθΥå˥󥰤Ǥϡ
	 *  p_runtskϴ˥ǥ塼鳰Ƥ뤿ᡤ
	 *  ʲifʸ̤ʤ
	 */
	if (queue_empty(&(p_tcb->task_queue)) == FALSE) {
		queue_delete(&(p_tcb->task_queue));
		if (queue_empty(&(ready_queue[remove_task_pri])) != FALSE) {
			primap_clear(remove_task_pri);
			nextpri = (primap_empty() != FALSE) ?	TPRI_MINTASK : primap_search();
		}
	}
}

#endif /* TOPPERS_remove_task_from_queue */

#ifdef TOPPERS_suspend_ready_task

/*
 *  ǥ塼äƤ륿ٻ߾֤ˤ
 */
void
suspend_ready_task(TCB *p_tcb, PriorityType remove_task_pri)
{
	p_tcb->tstat = SUSPENDED;
	LOG_TSKSTAT(p_tcb);
	remove_task_from_queue(p_tcb, remove_task_pri);
	if (p_tcb->actcnt > 0U) {
		p_tcb->actcnt -= 1U;
		(void) make_active(p_tcb);
	}
}

#endif /* TOPPERS_suspend_ready_task */

/*
 *  ζλ
 *    ProtectionHook Τ߸ƽФ
 *      ꥽β߶ػߤβԤä
 *       TerminateTaskνԤ
 *      λξϡPostTaskHookƽФʤΤTerminateTask
 *      ȤϰۤʤȤʤ
 *  ܴؿOS߶ػ߾֤ǸƽФ뤳ȤȤ
 */
#ifdef TOPPERS_force_terminate_task

void
force_terminate_task(TCB *p_tcb, StatusType terminate_cause)
{
	/* curpriinipriۤʤͤǥǥ塼˷ҤƤؤб */
	PriorityType remove_task_pri = p_tcb->curpri;

	/*
	 *  ߶ػߤ
	 *  顼եåϸƤФʤ
	 *  顼եåƤФʤᡤOSServiceId_Invalid򤹤
	 */
	release_interrupts(OSServiceId_Invalid);

	/* ꥽ݤޤޤξ硤꥽ */
	release_taskresources(p_tcb);
	/* 󥿤ξ֤ */
	cancel_taskcounters(p_tcb);

	if ((p_tcb == p_runtsk) && (p_runtsk == p_schedtsk)) {

		/* ¹楿CPU㳰, ȯΥå˥, ؿλΥå˥ */
		suspend();
	}
	else {
		/*
		 *  curpriinipriۤʤͤǥǥ塼˷ҤƤؤ
		 *  бǡ꥽ͥ٤Ѥ
		 */
		if (p_tcb == p_schedtsk) {
			search_schedtsk();
		}
		suspend_ready_task(p_tcb, remove_task_pri);
	}

	exit_and_dispatch_nohook();
}

#endif /* TOPPERS_force_terminate_task */
