/*
 *  TOPPERS ATK2
 *      Toyohashi Open Platform for Embedded Real-Time Systems
 *      Automotive Kernel Version 2
 *
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2004-2015 by Center for Embedded Computing Systems
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *  Copyright (C) 2011-2015 by FUJI SOFT INCORPORATED, JAPAN
 *  Copyright (C) 2011-2013 by Spansion LLC, USA
 *  Copyright (C) 2011-2015 by NEC Communication Systems, Ltd., JAPAN
 *  Copyright (C) 2011-2015 by Panasonic Advanced Technology Development Co., Ltd., JAPAN
 *  Copyright (C) 2011-2014 by Renesas Electronics Corporation, JAPAN
 *  Copyright (C) 2011-2015 by Sunny Giken Inc., JAPAN
 *  Copyright (C) 2011-2015 by TOSHIBA CORPORATION, JAPAN
 *  Copyright (C) 2004-2015 by Witz Corporation
 *  Copyright (C) 2014-2015 by AISIN COMCRUISE Co., Ltd., JAPAN
 *  Copyright (C) 2014-2015 by eSOL Co.,Ltd., JAPAN
 *  Copyright (C) 2014-2015 by SCSK Corporation, JAPAN
 *
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 *
 *  ܥեȥϡAUTOSARAUTomotive Open System ARchitecture˻
 *  ͤ˴ŤƤ롥嵭εϡAUTOSARŪ⻺Τ
 *  ϤʤAUTOSARϡAUTOSARͤ˴ŤեȥŪ
 *  ѤԤФơAUTOSARѡȥʡˤʤ뤳ȤƤ롥
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 *
 *  $Id$
 */


/*
 *  ߥݸ⥸塼
 *
 */
#include "kernel_impl.h"
#include "task.h"
#include "interrupt.h"
#include "target_timingprotection.h"
#include "timingprotection.h"

/*
 *  ߥݸǽν
 */
#ifdef TOPPERS_tp_initialize

volatile boolean	is_tp_timer_running;
volatile uint32		tp_time_count;


void
tp_initialize(void)
{
	is_tp_timer_running = FALSE;
	target_tp_initialize();
}

#endif /* TOPPERS_tp_initialize */

/*
 *  ߥݸǽνλ
 *  OS٥ǸƤӽФ
 */
#ifdef TOPPERS_tp_terminate

void
tp_terminate(void)
{
	is_tp_timer_running = FALSE;
	target_tp_terminate();
}

#endif /* TOPPERS_tp_terminate */

/*
 *  ޤεư
 *  OS٥ǸƤӽФ
 */
#ifdef TOPPERS_tp_start_timer

void
tp_start_timer(TickType tick)
{
	is_tp_timer_running = TRUE;
	target_tp_start_timer(tick);
}

#endif /* TOPPERS_tp_start_timer  */

/*
 *  ޤ߽
 *  OS٥ǸƤӽФ
 */
#ifdef TOPPERS_tp_stop_timer

TickType
tp_stop_timer(void)
{
	is_tp_timer_running = FALSE;
	return(target_tp_stop_timer());
}

#endif /* TOPPERS_tp_stop_timer */

/*
 *  ߥݸޤγ
 *  ߼¹楿Υߥݸδƻ뤬ɬפʤ鳫Ϥ
 *  OS٥ǸƤӽФ
 */
#ifdef TOPPERS_tp_start_task_monitor

void
tp_start_task_monitor(void)
{
	TCB *tcb = p_runtsk;

	ASSERT(tcb != NULL);

	if (tcb->tpcb.remaining_execution != 0U) {
		target_tp_start_timer(tcb->tpcb.remaining_execution);
		is_tp_timer_running = TRUE;
	}
	else {
		is_tp_timer_running = FALSE;
	}
}

#endif /* TOPPERS_tp_start_task_monitor */

/*
 *  ߥݸޤ
 *  ߼¹楿Υߥݸδƻߤ
 *  OS٥ǸƤӽФ
 */
#ifdef TOPPERS_tp_stop_task_monitor

void
tp_stop_task_monitor(void)
{
	TCB *tcb = p_runtsk;

	ASSERT(tcb != NULL);

	if (is_tp_timer_running != FALSE) {
		tcb->tpcb.remaining_execution = target_tp_stop_timer();
		is_tp_timer_running = FALSE;
	}
}

#endif /* TOPPERS_tp_stop_task_monitor */

/*
 *  ߻μ
 */
#ifdef TOPPERS_tp_get_current_time

void
tp_get_current_time(TFTIME *tftime)
{
	TickType	tick1;
	TickType	tick2;
	uint32		current_count;
	boolean		is_timeout;
	SIL_PRE_LOC;

	SIL_LOC_INT();

	current_count = tp_time_count;
	tick1 = target_tp_get_elapsed_ticks();
	is_timeout = target_tp_sense_interrupt();
	tick2 = target_tp_get_elapsed_ticks();

	SIL_UNL_INT();

	if ((is_timeout != FALSE) && (tick2 >= tick1)) {
		/* ߶ػ߸塤tick1˥ॢȤƤ */
		current_count++;
	}

	tftime->count = current_count;
	tftime->tick = tick1;

	return;
}

#endif /* TOPPERS_tp_get_current_time */


/*
 *  C2ISRֳ֥å
 *  OS٥ǸƤӽФ
 */
#ifdef TOPPERS_tp_check_c2isr_arrival_time

void
tp_check_c2isr_arrival_time(void)
{
	TFTIME	now;
	TFTIME	diff;
	ISRCB	*p_isrcb = p_runisr;

	ASSERT(p_isrcb != NULL);

	if (is_time_frame_available(&p_isrcb->p_intinib->time_frame) != FALSE) {
		/*
		 *  C2ISRݸͭ
		 */
		tp_get_current_time(&now);

		if (p_isrcb->is_not_first != FALSE) {
			/*
			 *  2ܰʹߤγߤֳ֤å
			 */

			/*
			 *  ưֳݸޤϾ˿ʤǤ뤫 now >= p_isrcb->lastarrivalΩ
			 */
			diff.count = now.count - p_isrcb->lastarrival.count;
			if (now.tick >= p_isrcb->lastarrival.tick) {
				diff.tick = now.tick - p_isrcb->lastarrival.tick;
			}
			else {
				/*
				 *  nowtickʬб
				 */
				diff.count--;
				diff.tick = ((TP_TIMER_MAX_TICK - p_isrcb->lastarrival.tick) + now.tick) + 1U;
			}

			if ((diff.count <= p_isrcb->p_intinib->time_frame.count) &&

				((diff.count != p_isrcb->p_intinib->time_frame.count) ||
				 (diff.tick < p_isrcb->p_intinib->time_frame.tick))) {

				call_protectionhk_main(E_OS_PROTECTION_ARRIVAL_ISR);
				/* PRO_IGNOREξäƤ */
			}
		}
		else {
			/*
			 *  γߤ̵̤
			 */

			p_isrcb->is_not_first = TRUE;
		}
		p_isrcb->lastarrival = now;

	}
}

#endif /* TOPPERS_tp_check_c2isr_arrival_time */

/*
 *  ֳ֥å
 *  OS٥ǸƤӽФ
 */
#ifdef TOPPERS_tp_check_task_arrival_time

boolean
tp_check_task_arrival_time(TCB *p_tcb)
{
	TFTIME	now;
	TFTIME	diff;
	boolean flg = TRUE;

	if (is_time_frame_available(&p_tcb->p_tinib->tpinib.time_frame) != FALSE) {
		/*
		 *  ֳݸͭ
		 */
		tp_get_current_time(&now);

		if (p_tcb->tpcb.is_not_first != FALSE) {
			/*
			 *  2ܰʹߤξֳ֤å
			 */
			/*
			 *  ưֳݸޤϾ˿ʤǤ뤫 now >= p_tcb->tpcb.arrival_timeΩ
			 */
			diff.count = now.count - p_tcb->tpcb.lastarrival.count;
			if (now.tick >= p_tcb->tpcb.lastarrival.tick) {
				diff.tick = now.tick - p_tcb->tpcb.lastarrival.tick;
			}
			else {
				/*
				 *  nowtickʬб
				 */
				diff.count--;
				diff.tick = ((TP_TIMER_MAX_TICK - p_tcb->tpcb.lastarrival.tick) + now.tick) + 1U;
			}

			if ((diff.count <= p_tcb->p_tinib->tpinib.time_frame.count) &&
				((diff.count != p_tcb->p_tinib->tpinib.time_frame.count) ||
				 (diff.tick < p_tcb->p_tinib->tpinib.time_frame.tick))) {
				flg = FALSE;
			}
		}
		else {
			/*
			 *  ξ̵̤
			 */
			p_tcb->tpcb.is_not_first = TRUE;
		}
		if (flg != FALSE) {
			p_tcb->tpcb.lastarrival = now;
		}
	}
	return(flg);
}

#endif /* TOPPERS_tp_check_task_arrival_time */

/*
 *  ߥݸƻ륿ޥϥɥ
 */
#ifdef TOPPERS_tp_fault_handler

void
tp_fault_handler(void)
{
	StatusType ercd = E_OS_PROTECTION_FATAL;

	target_clear_tp_fault_status();

	if (p_runtsk->tpcb.watchtype == TASK_MONITORING) {
		ercd = E_OS_PROTECTION_TIME_TASK;
	}
	else if (p_runtsk->tpcb.watchtype == RESOURCE_MONITORING) {
		ercd = E_OS_PROTECTION_LOCKED_RESOURCE;
	}
	else if (p_runtsk->tpcb.watchtype == LOCKOSINT_MONITORING) {
		ercd = E_OS_PROTECTION_LOCKED_OSINT;
	}
	else {
		ASSERT(0);
	}

	call_protectionhk_main(ercd);

	internal_shutdownos(E_OS_SYS_ASSERT_FATAL);
	/* ƤӽФˤʤ */
}

#endif /* TOPPERS_tp_fault_handler */

/*
 *  ߥݸѥޥϥɥ
 */
#ifdef TOPPERS_tp_timer_handler

void
tp_timer_handler(void)
{
	target_clear_tp_timer_status();

	tp_time_count++;
}

#endif /* TOPPERS_tp_timer_handler */
